%{
#define YYDEBUG 1

/* #include "asm51.h" */
typedef unsigned char byte;

extern printf ( char *, ... );
extern yyerror ( char * );
extern yylex ( void );

unsigned code_loc;
unsigned vcode_loc;
unsigned data_loc;
unsigned daddr;
extern int pass; //, listflag;
//extern char mytmpstr[], tmpch1[], liststr[];
//extern FILE *out_lstfile;
int i, tmplen;

//extern MAX_STRLEN;

extern void emit ( byte );
extern void listout( void );
//extern void define_symbol ( int i, int v );
extern unsigned resolve_label ( char *s );
extern char yystring[];
extern int change_src_file ( char* fname );
extern void init_from_file ( char* fname, int bits );
extern void listout(void);
%}

%start PROGRAM_51

%token NUMBER		/* 0 and 1 are special cases */
	LABEL			/* symbol such as const or label */
	STRING			/* literal string in double quotes */
	ORG
	DB
	DW
	HB              /* Hi byte */
	LB              /* Lo byte */
	SHIFTL          /* << */
	SHIFTR          /* >> */

	A               /* ACC for 1 addr command */
	AB              /* AB for mult/div */
	C               /* C for bit op */
	NR              /* NamedRegisters */
	NB              /* NamedBit */
	DPTR            /* -- */
	PC              /* -- */
	R01             /* r0, r1 */
	R27             /* r2, r3 ... r7 */

	B1              /* null arg op (nop, ret ..) */
	B1A             /* op with ACC (no data - rr, rlc ... ) */
	INCDEC          /* inc & dec */
	MD              /* mult/div */
	AS              /* add, addc, subb */
	XCH             /* -- */
	XCHD            /* -- */
	LF              /* LogicFunc (anl, orl, xrl) */
	BOP             /* BitOp (clr, cpl, setb) */
	PP              /* push, pop */

	MOV             /* -- */
	MOVC            /* -- */
	MOVX            /* -- */

	JPB             /* Jump_if_Bit */
	JP8             /* jump on byte addr */
	JP12            /* jump on 12 bit addr (in page) */
	JP16            /* word jump */
	JMP             /* -- */
	CJNE            /* -- */
	DJNZ            /* -- */

	DS              /* DefineStory */
	DATA            /* assembler command */
	INCLUDE
	END
	WIDTH
	EOL
%%

PROGRAM_51 : PROG_UNIT
	| PROGRAM_51 PROG_UNIT
	| PROGRAM_51 END
	;

PROG_UNIT : DIRECTIVE	/* can not place ';' here because of problems */
	| COMMAND_L EOL { code_loc = vcode_loc; }      /* with .include directive */
	| EOL
	| error EOL { yyerrok; }
	;

COMMAND_L : OP_51 { listout(); }
	| LABEL ':' OP_51 { insert_label ( yystring, code_loc ); listout(); }
	| LABEL ':' { insert_label ( yystring, code_loc ); }
	| DATA EXPR { data_loc = $2 & 0xff; }
	| LABEL ':' DS { insert_label ( yystring, data_loc ); data_loc++; }
	| LABEL ':' DS EXPR { insert_label ( yystring, data_loc ); data_loc += $4 & 0xff; };


DIRECTIVE : INCLUDE STRING EOL { change_src_file ( yystring ); };


OP_51 :
	B1 { emit( $1 ); } |
	B1A A { emit( $1 ); } |
	INCDEC A { emit( $1 ); } |
	INCDEC  DIR { emit( $1 + 1 ); emit( $2 ); } |
	INCDEC '@' R01 { emit( $1 + 2 + $3 ); } |
	INCDEC  R07 { emit( $1 + 4 + $2); } |
	INCDEC DPTR { if( $1 != 0x04 )
					yyerror("Illegal instruction");
				else emit( 0xA3 ); } |
	MD AB { emit( $1 ); } |
	AS A ',''#' EXPR { emit( $1 ); emit( $5 ); } |
	AS A ',' DIR { emit( $1 + 1 ); emit( $4 ); } |
	AS A ',' '@' R01 { emit( $1 + 2 + $5 ); } |
	AS A ',' R07 { emit( $1 + 4 + $4 ); } |
	JPB BIT ',' ADDR83 { emit( $1 ); emit( $2 ); emit( $4 ); } |
	JP8 ADDR82 { emit( $1 ); emit( $2 ); } |
	JP12 ADDR122 { emit( $1 | (($2>>3) & 0xE0 )); emit($2 & 0xFF); } |
	JP16 EXPR { emit( $1 ); emit(($2>>8) & 0xFF); emit($2 & 0xFF); } |
	JMP EXPR { emit( 0x02 ); emit(($2>>8) & 0xFF); emit($2 & 0xFF); } |
	JMP '@' A '+' DPTR { emit ( $1 ); } |
	CJNE A ',' '#' DATA8 ',' ADDR83 { emit( $1 ); emit( $5 ); emit( $7 ); } |
	CJNE A ',' DIR ',' ADDR83 { emit( $1 + 1 ); emit( $4 ); emit( $6 ); } |
	CJNE '@' R01 ',' '#' DATA8 ',' ADDR83
						{ emit( $1 + 2 + $3 ); emit( $6 ); emit( $8 ); } |
	CJNE R07 ',' '#' DATA8 ',' ADDR83
						{ emit( $1 + 4 + $2 ); emit( $5 ); emit( $7 ); } |
	DJNZ DIR ',' ADDR83 { emit ( $1 ); emit( $2 ); emit( $4 ); } |
	DJNZ R07 ',' ADDR82 { emit ( $1 + 3 + $2 ); emit( $4 ); } |
	PP DIR { emit( $1 ); emit( $2 ); } |
	LF DIR ',' A { emit( $1 ); emit( $2 ); } |
	LF DIR ',' '#' DATA8 { emit( $1 + 1 ); emit( $2 ); emit( $5 ); } |
	LF A ',' '#' DATA8 { emit( $1 + 2 ); emit( $5 ); } |
	LF A ',' DIR { emit( $1 + 3 ); emit( $4 ); } |
	LF A ',' '@' R01 { emit( $1 + 4 + $5 ); } |
	LF A ',' R07 { emit( $1 + 6 + $4 ); } |
	LF C ',' '/' BIT { if( $1 == 0x62 )
							yyerror("Illegal address mode for XRL");
						emit( $1 + 0x5E ); emit( $5 ); } |
	LF C ',' BIT { if( $1 == 0x62 )
							yyerror("Illegal address mode for XRL");
						emit( $1 + 0x30 ); emit( $4 ); } |
	BOP BIT { emit( $1 ); emit( $2 ); } |
	BOP C { emit( $1 + 1 ); } |
	BOP A { if( $1 == 0xD2 )
			yyerror("Illegal arg for SETB");
			if( $1 == 0xB2 )
				emit( 0xF4 );
			if( $1 == 0xC2 )
				emit( 0xE4 ); } |
	XCH A ',' DIR { emit( $1 ); emit( $4 ); } |
	XCH A ',' '@' R01 { emit( $1 + 1 + $5 ); } |
	XCH A ',' R07 { emit( $1 + 3 + $4 ); } |
	XCHD A ',' '@' R01 { emit( $1 + $5 ); } |
	MOV DPTR ',' '#' EXPR { emit( 0x90 ); emit(($5>>8) & 0xFF); emit( $5 &0xFF ); } |
/*	MOV BIT ',' C { emit( 0x92 ); emit( $2 ); } |
	MOV DIR ',' '#' DATA8 { emit( 0x75 ); emit( $2 ); emit( $5 ); } |
	MOV DIR ',' DIR { emit( 0x85 ); emit( $4 ); emit( $2 ); } |
	MOV DIR ',' '@' R01 { emit( 0x86 + $5 ); emit( $2 ); } |
	MOV DIR ',' R07 { emit( 0x88 + $4 ); emit( $2 ); } |
	MOV DIR ',' A { emit( 0xF5 ); emit( $2 ); } | */

	MOV EXPR ',' C { emit( 0x92 ); emit( $2 ); } |
	MOV EXPR '.' EXPR ',' C { if(($2 < 0x20) || (0x2F < $2))
								yyerror("Addr byte for bit addressig mode out of range");
							if($4 > 7)
								yyerror("Invalid bit number");
							emit( 0x92 ); emit(($2 - 0x20)<<3 + $4); } |
	MOV NR '.' EXPR ',' C { if(($2 & 0xF8) != $2)
						yyerror("Bit addressing not allowed for this register");
					if(($4 & 0x7) != $4)
						yyerror("Bad bit specifications");
					emit( 0x92 ); emit($2 + $4); } |
	MOV NB ',' C { emit( 0x92 ); emit( $2 ); } |
	MOV EXPR ',' '#' DATA8 { emit( 0x75 ); emit( $2 ); emit( $5 ); } |
	MOV EXPR ',' DIR { emit( 0x85 ); emit( $4 ); emit( $2 ); } |
	MOV EXPR ',' '@' R01 { emit( 0x86 + $5 ); emit( $2 ); } |
	MOV EXPR ',' R07 { emit( 0x88 + $4 ); emit( $2 ); } |
	MOV EXPR ',' A { emit( 0xF5 ); emit( $2 ); } |
	MOV NR ',' '#' DATA8 { emit( 0x75 ); emit( $2 ); emit( $5 ); } |
	MOV NR ',' DIR { emit( 0x85 ); emit( $4 ); emit( $2 ); } |
	MOV NR ',' '@' R01 { emit( 0x86 + $5 ); emit( $2 ); } |
	MOV NR ',' R07 { emit( 0x88 + $4 ); emit( $2 ); } |
	MOV NR ',' A { emit( 0xF5 ); emit( $2 ); } |

	MOV C ',' BIT { emit( 0xA2 ); emit( $4 ); } |
	MOV A ',' '#' DATA8 { emit( 0x74 ); emit( $5 ); } |
	MOV '@' R01 ',' '#' DATA8 { emit( 0x76 + $3 ); emit( $6 ); } |
	MOV R07 ',' '#' DATA8 { emit( 0x78 + $2 ); emit( $5 ); } |
	MOV '@' R01 ',' DIR { emit( 0xA6 + $3 ); emit( $5 ); } |
	MOV R07 ',' DIR { emit( 0xA8 + $2 ); emit( $4 ); } |
	MOV A ',' DIR { emit( 0xE5 ); emit( $4 ); } |
	MOV A ',' '@' R01 { emit( 0xE6 + $5 ); } |
	MOV A ',' R07 { emit( 0xE8 + $4 ); } |
	MOV '@' R01 ',' A { emit( 0xF6 + $3 ); } |
	MOV R07 ',' A { emit( 0xF8 + $2 ); } |
	MOVC A ',' '@' A '+' PC { emit( $1 ); } |
	MOVC A ',' '@' A '+' DPTR { emit( $1 + 0x10 ); } |
	MOVX A ',' '@' DPTR { emit( $1 ); } |
	MOVX A ',' '@' R01 { emit( $1 + 2 + $5 ); } |
	MOVX '@' DPTR ',' A { emit( $1 + 0x10 ); } |
	MOVX '@' R01 ',' A { emit( $1 + 0x10 + 2 + $3 ); } |
	WIDTH EXPR { } |
	ORG EXPR {
				/* if( $2 != 0 )
					yyerror("Not use directive Org!"); */
				if( $2 < code_loc )
					yyerror("Uncorrect directive Org");
				else
					for(i=code_loc; i< $2; i++)
						emit(0xFF);
				} |
	DB EXPRDB1	{	} |
	DW EXPRDW1	{	};


R07 : R01 { $$ = $1; } |
	R27 { $$ = $1; };

DIR : EXPR { $$ = $1; } |
	NR { $$ = $1; };

DATA8 : EXPR { /* if(($1 & 0xFF) != $1)
					yyerror("Data out of range"); */
				$$ = $1 & 0xFF; };

BIT :   EXPR { $$ = $1; } |
	EXPR '.' EXPR { if(($1 < 0x20) || (0x2F < $1))
								yyerror("Addr byte for bit addressig mode out of range (20-2f)");
							if(($3 > 7) || ($3 < 0))
								yyerror("Invalid bit number");
							$$ = ($1 - 0x20)<<3 + $3; } |
	NR '.' EXPR { if(($1 & 0xF8) != $1)
						yyerror("Bit addressing not allowed for this n_register");
					if(($3 & 0x7) != $3)
						yyerror("Bad bit specifications");
					$$ = $1 + $3; } |
	NB { $$ = $1; };

ADDR122 : EXPR { daddr = $1;
				if((pass == 1) ||
				((daddr & 0xF800) == ((code_loc + 2) & 0xF800)))
					$$ = daddr;
				else yyerror("Addr12 out of range (2Kb page)"); };

ADDR82 : EXPR {	daddr = $1 - (code_loc+2);
				if((pass == 1)||
					(((daddr & 0xFF00) == 0)&&(daddr <= 0x7F))||
					(((daddr & 0xFF00) == 0xFF00)&&((daddr & 0xFF) >= 0x80)))
						$$ = daddr & 0xFF;
				else yyerror("Jump distance out of range."); };

ADDR83 : EXPR {	daddr = $1 - (code_loc+3);
				if((pass == 1)||
					(((daddr & 0xFF00) == 0)&&(daddr <= 0x7F))||
					(((daddr & 0xFF00) == 0xFF00)&&((daddr & 0xFF) >= 0x80)))
						$$ = daddr & 0xFF;
				else yyerror("Jump distance out of range."); };

EXPR : EXPR1 { $$ = $1; } |
	HB EXPR1 { $$ = ($2>>8) & 0xFF; } |
	LB EXPR1 { $$ = $2 & 0xFF; };

EXPR1 : EXPR2 { $$ = $1; } |
	'-' EXPR2 { $$ = - $2; } |
	'~' EXPR2 { $$ = ~ $2; } |
	EXPR1 '+' EXPR2 { $$ = $1 + $3; } |
	EXPR1 '-' EXPR2 { $$ = $1 - $3; } |
	EXPR1 '|' EXPR2 { $$ = $1 | $3; };

EXPR2: EXPR3 { $$ = $1; } |
EXPR2 '&' EXPR3 { $$ = $1 & $3; } |
EXPR2 '^' EXPR3 { $$ = $1 ^ $3; } |
EXPR2 '/' EXPR3 { $$ = $1 / $3; } |
EXPR2 '%' EXPR3 { $$ = $1 % $3; } |
EXPR2 SHIFTL EXPR3 { $$ = $1 << $3; } |
EXPR2 SHIFTR EXPR3 { $$ = $1 >> $3; } |
EXPR2 '*' EXPR3 { $$ = $1 * $3; };
 
EXPR3: NUMBER { $$ = $1; } |
	STRING { if(strlen(yystring) != 1)
				yyerror("Too many characters");
			else $$ = yystring[0]; } |
	LABEL { $$ = resolve_label ( yystring ); } |
	'$' { $$ = code_loc; } |
	'(' EXPR ')' { $$ = $2; };

EXPRDB1 :
	EXPRDB1 ',' EXPRDB2 { emit( $3 ); } |
	EXPRDB1 ',' STRING { tmplen = strlen(yystring);
			for(i=0; i < tmplen; i++)
				emit(yystring[i]); } |
	EXPRDB2 { emit( $1 ); } |
	STRING { tmplen = strlen(yystring);
			for(i=0; i < tmplen; i++)
				emit(yystring[i]); };

EXPRDB2 : EXPRDB3 { $$ = $1; } |
	'-' EXPRDB3 { $$ = - $2; } |
	EXPRDB2 '+' EXPRDB3 { $$ = $1 + $3; } |
	EXPRDB2 '-' EXPRDB3 { $$ = $1 - $3; } |
	EXPRDB2 '|' EXPRDB3 { $$ = $1 | $3; };

EXPRDB3 : EXPRDB4 { $$ = $1; } |
	EXPRDB3 '&' EXPRDB4 { $$ = $1 & $3; };

EXPRDB4: NUMBER { $$ = $1; } |
	LABEL { $$ = resolve_label ( yystring ); };

EXPRDW1 :
	EXPRDW1 ',' EXPRDW2 { emit( ($3>>8) & 0xFF ); emit( $3 & 0xFF ); } |
	EXPRDW1 ',' STRING { tmplen = strlen(yystring);
			for(i=0; i < tmplen; i++)
				{
				emit(0);
				emit(yystring[i]);
				} } |
	EXPRDW2 { emit( ($1>>8) & 0xFF ); emit($1 & 0xFF); } |
	STRING { tmplen = strlen(yystring);
			for(i=0; i < tmplen; i++)
				{
				emit(0);
				emit(yystring[i]);
				} };

EXPRDW2 : EXPRDW3 { $$ = $1; } |
	'-' EXPRDW3 { $$ = - $2; } |
	EXPRDW2 '+' EXPRDW3 { $$ = $1 + $3; } |
	EXPRDW2 '-' EXPRDW3 { $$ = $1 - $3; } |
	EXPRDW2 '|' EXPRDW3 { $$ = $1 | $3; };

EXPRDW3 : EXPRDW4 { $$ = $1; } |
	EXPRDW3 '&' EXPRDW4 { $$ = $1 & $3; };

EXPRDW4: NUMBER { $$ = $1; } |
	LABEL { $$ = resolve_label ( yystring ); };
/* -------------------------------------------------- */
